{=====================================================================}
{                                                                     }
{ Alias ComboBox, Table Name ComboBox.                                }
{   for Borland Database Engin. ver 1.4.0 5/Apr./'97                  }
{ http://www.kobira.co.jp/sakura/windows.htm                          }
{ author Seiji-Yasuda seiji@kobira.co.jp                              }
{ based on AliasEd.pas by Glenn Davies(Glenn@home-pc.demon.co.uk)     }
{                                                                     }
{ You may use it freely at your own risk in any kind of environment.  }
{                                                                     }
{ Note:                                                               }
{  9/Feb./'97 ver 1.0.0                                               }
{   first version. based on AliasEd.pas by Glenn Davies               }
{  30/Mar./'97 ver 1.1.0                                              }
{   inherited TComboBox --> TCustomComboBox                           }
{   support IME (for Japanese Kanji)                                  }
{   style := csOwnerDrawFixed                                         }
{  1/Apr./'97 ver 1.2.0                                               }
{   supported Table Name ComboBox                                     }
{  3/Apr./'97 ver 1.3.0                                               }
{   supported flush procedure.                                        }
{  5/Apr./'97 ver 1.4.0                                               }
{   supported property SystemTables, Extensions.                      }
{                                                                     }
{=====================================================================}

(*$DEFINE USLIB*) // for non-Japanese Delphi.

unit TAlsCom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB;

type
  TAliasComboBox = class(TCustomComboBox)
  private
    fConfigMode   : TConfigMode;   // this component BDE's configuration mode.
    fOldConfigMode: TConfigMode;   // original BDE's configuration mode.

  protected
    procedure InitBde;             // set acvive BDE's session.
    procedure RestoreSessionConfigMode;   // restore configuration mode.
    procedure SetSessionConfigMode;       // set configuration mode.
    procedure CreateWnd; override;
    procedure SetConfigMode(Value: TConfigMode);
  public
    Params : TStringList;           // buffer.
    constructor Create(owner: TComponent); override;
    destructor  Destroy; override;
    procedure Flush;
    procedure Add(const alias, driver: String; the_params: TStrings);
    procedure Delete(const alias: String);
    function  Exists(const alias: String): Boolean;
    procedure Modify(const alias: String; the_params: TStrings);
    procedure GetAliasList(the_params: TStrings);
    function  GetDriver(const alias: String): String;
    procedure GetParams(const alias: String; the_params: TStrings);
    function  GetPath(const alias: String): String;
    function  GetType(const alias: String): String;

   published
//  property Style; {Must be published before Items}
    property Color;
    property Ctl3D;
    property ConfigMode: TConfigMode
      read fConfigMode write SetConfigMode default cmPersistent;
//  property DragMode;
//  property DragCursor;
//  property DropDownCount;
    property Enabled;
    property Font;
(*$IFNDEF USLIB*)
//  property ImeMode;
(*$ENDIF  USLIB*)
    property ItemHeight;
//  property Items;
//  property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
//  property PopupMenu;
    property ShowHint;
//  property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange ;
    property OnClick;
    property OnDblClick;
//  property OnDragDrop;
//  property OnDragOver;
    property OnDrawItem;
//  property OnDropDown;
//  property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
//  property OnMeasureItem;
//  property OnStartDrag;
  end;


  TTableComboBox = class(TCustomComboBox)
  private
    fConfigMode   : TConfigMode;   // this component BDE's configuration mode.
    fOldConfigMode: TConfigMode;   // original BDE's configuration mode.
    fDataBaseName : string;        // data base.
    fPattern: string;
    fExtensions : boolean;
    fSystemTables : boolean;
    procedure SetfDataBaseName( s : string );

  protected
    procedure InitBde;             // set acvive BDE's session.
    procedure RestoreSessionConfigMode;   // restore configuration mode.
    procedure SetSessionConfigMode;       // set configuration mode.
    procedure CreateWnd; override;

  public
    Params : TStringList;           // buffer.
    constructor Create(owner: TComponent); override;
    destructor  Destroy; override;
    procedure Flush;
    procedure GetTableList(the_params: TStrings);

   published
//  property Style; {Must be published before Items}
    property Color;
    property Ctl3D;
    property ConfigMode: TConfigMode read fConfigMode write fConfigMode default cmPersistent;
    property DataBaseName : string read fDataBaseName write SetfDataBaseName;
//  property DragMode;
//  property DragCursor;
//  property DropDownCount;
    property Enabled;
    property Extensions : boolean read fExtensions write fExtensions default True;
    property Font;
(*$IFNDEF USLIB*)
//  property ImeMode;
(*$ENDIF  USLIB*)
    property ItemHeight;
//  property Items;
//  property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property Pattern: string read fPattern write fPattern;
//  property PopupMenu;
    property ShowHint;
//  property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
//  property OnDragDrop;
//  property OnDragOver;
    property OnDrawItem;
//  property OnDropDown;
//  property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
//  property OnMeasureItem;
//  property OnStartDrag;
    property SystemTables : boolean read FSystemTables write FSystemTables default True;

  end;


procedure Register;

implementation



{ TAliasComboBox }

//---------------------------------------------------------------------
// set acvive BDE's session.

procedure TAliasComboBox.InitBDE;
begin
  if not Session.Active then begin
    Session.Active := TRUE;
  end;
end;


//---------------------------------------------------------------------
// restore configuration mode.

procedure TAliasComboBox.RestoreSessionConfigMode;
begin
  Session.ConfigMode := fOldConfigMode;
end;


//---------------------------------------------------------------------
// set configuration mode.

procedure TAliasComboBox.SetSessionConfigMode;
begin
  fOldConfigMode := Session.ConfigMode;
  Session.ConfigMode := fConfigMode;
end;


//---------------------------------------------------------------------
procedure TAliasComboBox.Flush;
begin
  // make buffer.
  GetAliasList(Params);
  items.clear;
  items.AddStrings(Params);
  if Params.Count > 0 then begin
     Text := Params.Strings[0];
     ItemIndex := 0;
  end else begin
     Text := '';
     ItemIndex := -1;
  end;

end;


//---------------------------------------------------------------------
// Create Window handle.

procedure TAliasComboBox.CreateWnd;
begin
  inherited CreateWnd;

  style := csOwnerDrawFixed;
  (*$IFNDEF USLIB*)
   ImeMode := imClose;     // for Japanese Kanji.
  (*$ENDIF  USLIB*)

  // Params := TStringList.Create;
  Flush;
  fConfigMode := cmPersistent;

end;


//---------------------------------------------------------------------
// create

constructor TAliasComboBox.Create(owner: TComponent);
begin
  Params := TStringList.Create;
  inherited Create(owner);

end;


//---------------------------------------------------------------------
// destroy

destructor TAliasComboBox.Destroy;
begin
  Params.Free;
  inherited Destroy;
end;



//---------------------------------------------------------------------
//  Add a new alias.

procedure TAliasComboBox.Add(const alias, driver: String; the_params: TStrings);
begin
  InitBDE;
  SetSessionConfigMode;
  try
    Session.AddAlias(alias, driver, the_params);
    Session.SaveConfigFile;
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Delete an existing alias.

procedure TAliasComboBox.Delete(const alias: String);
begin
  InitBDE;
  SetSessionConfigMode;
  try
    Session.DeleteAlias(alias);
    Session.SaveConfigFile;
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Check if an alias exists.

function TAliasComboBox.Exists(const alias: String): Boolean;
begin
  result := False;
  InitBDE;
  SetSessionConfigMode;
  try
    result := Session.IsAlias(alias);
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Modify an existing alias.

procedure TAliasComboBox.Modify(const alias: String; the_params: TStrings);
begin
  InitBDE;
  SetSessionConfigMode;
  try
    Session.ModifyAlias(alias, the_params);
  { SaveConfigFile saves all global aliases permanently in
    the BDE configuration file: }
    Session.SaveConfigFile;
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Get a list of available aliases.

procedure TAliasComboBox.GetAliasList(the_params: TStrings);
begin
  InitBDE;
  SetSessionConfigMode;
  try
    Session.GetAliasNames(the_params);
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Get the driver name for an alias.

function TAliasComboBox.GetDriver(const alias: String): String;
begin
  InitBDE;
  SetSessionConfigMode;
  try
    result := Session.GetAliasDriverName(alias)
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Get the parameters for an alias.

procedure TAliasComboBox.GetParams(const alias: String; the_params: TStrings);
begin
  InitBDE;
  SetSessionConfigMode;
  try
    Session.GetAliasParams(alias, the_params);
  finally
    RestoreSessionConfigMode;
  end;
end;


//---------------------------------------------------------------------
//  Get the path for an alias.

function TAliasComboBox.GetPath(const alias: String): String;
var
  the_params: TStringList;
begin
  the_params := TStringList.Create;
  try
    GetParams(alias,the_params);
    result := the_params.Values['PATH'];
  finally
    the_params.Free;
  end;
end;


//---------------------------------------------------------------------
//  Get the type of an alias.

function TAliasComboBox.GetType(const alias: String): String;
var
  the_params: TStringList;
begin
  the_params := TStringList.Create;
  try
    GetParams(alias,the_params);
    result := the_params.Values['TYPE'];
  finally
    the_params.Free;
  end;
end;

//---------------------------------------------------------------------
procedure TAliasComboBox.SetConfigMode(Value: TConfigMode);
begin
  if (Value <> fConfigMode) then
  begin
    fConfigMode := Value;
    Flush;
  end;
end;


{ TTableComboBox }


//---------------------------------------------------------------------
// set acvive BDE's session.

procedure TTableComboBox.InitBDE;
begin
  if not Session.Active then begin
    Session.Active := TRUE;
  end;
end;


//---------------------------------------------------------------------
// restore configuration mode.

procedure TTableComboBox.RestoreSessionConfigMode;
begin
  Session.ConfigMode := fOldConfigMode;
end;


//---------------------------------------------------------------------
// set configuration mode.

procedure TTableComboBox.SetSessionConfigMode;
begin
  fOldConfigMode := Session.ConfigMode;
  Session.ConfigMode := fConfigMode;
end;

//---------------------------------------------------------------------
//  Get a list of available aliases.

procedure TTableComboBox.GetTableList(the_params: TStrings);
begin
  InitBDE;
  SetSessionConfigMode;
  try
    try
      Session.GetTableNames( DatabaseName, fPattern, fExtensions, fSystemTables, the_Params );
    except
      Params.Clear;
    end;
  finally
    RestoreSessionConfigMode;
  end;
end;

//---------------------------------------------------------------------
procedure TTableComboBox.Flush;
begin
  // make buffer.
  Params.Clear;
  GetTableList( Params );
  items.clear;
  items.AddStrings(Params);
  if Params.Count > 0 then begin
     Text := Params.Strings[0];
     ItemIndex := 0;
  end else begin
     Text := '';
     ItemIndex := -1;
  end;

end;


//---------------------------------------------------------------------
// Create Window handle.

procedure TTableComboBox.CreateWnd;
begin
  inherited CreateWnd;

  style := csOwnerDrawFixed;
  (*$IFNDEF USLIB*)
   ImeMode := imClose;     // for Japanese Kanji.
  (*$ENDIF  USLIB*)

  // Params := TStringList.Create;
  Flush;
  fConfigMode := cmPersistent;

  if Pattern = '' then begin
    fPattern := '*.*';
    Pattern := '*.*';
  end;

end;


//---------------------------------------------------------------------
// create

constructor TTableComboBox.Create(owner: TComponent);
begin
  inherited Create(owner);
  fExtensions   := True;
  fSystemTables := True;
  Params := TStringList.Create;

end;


//---------------------------------------------------------------------
// destroy

destructor TTableComboBox.Destroy;
begin
  Params.Free;
  inherited Destroy;
end;


//---------------------------------------------------------------------
// set fDataBaseName

procedure TTableComboBox.SetfDataBaseName( s : string );
begin


  // set fDataBaseName
  fDataBaseName := s;

  // make buffer.
  Flush;

  if Assigned(OnChange) then OnChange(application);


end;


//---------------------------------------------------------------------
// Register

procedure Register;
begin
  RegisterComponents('Data Controls', [TAliasComboBox]);
  RegisterComponents('Data Controls', [TTableComboBox]);
end;




end.
