unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TAlsCom, DB, Grids, DBGrids, DBTables, TPrnCom;

type
  TForm1 = class(TForm)
    AliasComboBox1: TAliasComboBox;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Memo1: TMemo;
    Label7: TLabel;
    TableComboBox1: TTableComboBox;
    Label8: TLabel;
    Label5: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    LabelExplainCM: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Disp;
    procedure AliasComboBox1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    procedure InsertSampleSessionAlias;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Disp;
begin
{ AliasComboBox1.Text := '';}
  Label4.Caption := '';
  Label6.Caption := '';
  Memo1.Lines.Clear;
  if AliasComboBox1.Text <> '' then begin
    Label4.Caption := AliasComboBox1.GetDriver(AliasComboBox1.Text);
    Label6.Caption := AliasComboBox1.GetPath(AliasComboBox1.Text);
    AliasComboBox1.GetParams(AliasComboBox1.Text, Memo1.Lines);
  end;
end;

procedure TForm1.InsertSampleSessionAlias;
var
  MyList: TStringList;
begin
  Session.ConfigMode := cmSession;
  Session.AddStandardAlias('TestSessionAlias1', 'C:\', 'PARADOX');
  MyList := TStringList.Create;
  with MyList do begin
    Add('PATH=C:\');
  end;
  Session.AddAlias('TestSessionAlias2', 'PARADOX', MyList);
  MyList.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InsertSampleSessionAlias;
  ComboBox1.ItemIndex := 0;
  ComboBox1.Text := ComboBox1.Items[ComboBox1.ItemIndex];
  ComboBox1Change(self);
end;

procedure TForm1.AliasComboBox1Change(Sender: TObject);
begin
  TableComboBox1.ConfigMode := AliasComboBox1.ConfigMode;
  TableComboBox1.DataBaseName := AliasComboBox1.Text;
  Disp;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin

  case ComboBox1.ItemIndex of
    0:
      begin
        LabelExplainCM.Caption :=
          'cmPersistent: Aliases you add are global. ' +
          '(Call SaveConfigFile to make permanent.) ' +
          'GetAliasNames returns only global aliases.';
        AliasComboBox1.ConfigMode := cmPersistent;
      end;

    1:
      begin
        LabelExplainCM.Caption :=
          'cmSession: Aliases you add are local and can''t be saved. ' +
          '(Local aliases are lost when the session ends.) ' +
          'GetAliasNames returns only local aliases.';
//        ShowMessage('This sample program does not support cmSession.');
      AliasComboBox1.ConfigMode := cmSession;
//        AliasComboBox1.ConfigMode := cmPersistent;
//        ComboBox1.ItemIndex := 0;
//        ComboBox1.Text := 'cmPersistent';
//        ComboBox1Change(self);
      end;

    2:
      begin
        LabelExplainCM.Caption :=
          'cmAll: Aliases you add are global. ' +
          '(Call SaveConfigFile to make permanent.) ' +
          'GetAliasNames returns both global and local aliases.';
        AliasComboBox1.ConfigMode := cmAll;
      end;
  end; // end of case
  AliasComboBox1Change(self);
end;



end.
